OGRE: Ogre::Volume::Chunk Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Volume::Chunk Class Reference
Optional Components » Volume

A single volume chunk mesh. More...

`#include <OgreVolumeChunk.h>`

Inheritance diagram for Ogre::Volume::Chunk:
[legend]

## Public Types
typedef std::vector< const Chunk * > | VecChunk
| A list of Chunks.
Public Types inherited from Ogre::ShadowCaster
typedef Ogre::ShadowRenderableList | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator
Public Types inherited from Ogre::Renderable
enum | { DEFAULT_PRIORITY = 100 }

## Public Member Functions
| Chunk (void)
| Constructor.
virtual | ~Chunk (void)
| Destructor.
virtual Chunk * | createInstance (void)
| Overridable factory method.
bool | frameStarted (const FrameEvent &evt) override
| Overridden from FrameListener.
Real | getBoundingRadius () const override
| Overridden from MovableObject.
ChunkParameters * | getChunkParameters (void)
| Gets the parameters with which the chunktree got loaded.
virtual void | getChunksOfLevel (const size_t level, VecChunk &result) const
| Gathers all visible chunks (containing triangles) of a specific LOD level.
virtual bool | getDualGridVisible (void) const
| Gets whether the debug visualization entity of the dualgrid is visible.
const String & | getMovableType (void) const override
| Overridden from MovableObject.
virtual bool | getOctreeVisible (void) const
| Gets whether the debug visualization entity of the octree is visible.
Real | getSquaredViewDepth (const Camera *camera) const override
| Overridden from Renderable.
virtual bool | getVolumeVisible (void) const
| Gets whether the volume mesh is visible.
virtual void | load (SceneNode *parent, const Vector3 &from, const Vector3 &to, size_t level, const ChunkParameters *parameters)
| Loads the volume mesh with all LODs.
virtual void | load (SceneNode *parent, SceneManager *sceneManager, const String &filename, bool validSourceResult=false, MeshBuilderCallback *lodCallback=0, const String &resourceGroup=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Loads a TextureSource volume scene from a config file.
virtual void | setDualGridVisible (const bool visible)
| Shows the debug visualization entity of the dualgrid.
void | setMaterial (const MaterialPtr &mat) override
| Overridden from SimpleRenderable.
void | setMaterialOfLevel (size_t level, const MaterialPtr &mat)
| Sets the material of all chunks of a specific level in the tree.
virtual void | setOctreeVisible (const bool visible)
| Shows the debug visualization entity of the octree.
virtual void | setVolumeVisible (const bool visible)
| Sets whether the volume mesh is visible.
Public Member Functions inherited from Ogre::SimpleRenderable
| SimpleRenderable ()
| Constructor.
| SimpleRenderable (const String &name)
| Named constructor.
void | _notifyCurrentCamera (Camera *cam) override
| Internal method to notify the object of the camera to be used for the next rendering operation.
void | _updateRenderQueue (RenderQueue *queue) override
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
const AxisAlignedBox & | getBoundingBox (void) const override
| Retrieves the local axis-aligned bounding box for this object.
const LightList & | getLights (void) const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const MaterialPtr & | getMaterial (void) const override
| Retrieves a weak reference to the material this renderable object uses.
void | getRenderOperation (RenderOperation &op) override
| Gets the render operation required to send this object to the frame buffer.
void | getWorldTransforms (Matrix4 *xform) const override
| Gets the world transform matrix / matrices for this renderable object.
void | setBoundingBox (const AxisAlignedBox &box)
virtual void | setRenderOperation (const RenderOperation &rend)
void | setTransform (const Affine3 &xform)
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false) override
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject ()
| Constructor.
| MovableObject (const String &name)
| Named constructor.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const Affine3 & | _getParentNodeFullTransform (void) const
| Return the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
Real | getBoundingRadiusScaled () const
| as getBoundingRadius, but with scaling applied
bool | getCastShadows (void) const override
| Returns whether shadow casting is enabled for this object.
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener (void) const
| Gets the current listener for this object.
const String & | getName (void) const
| Returns the name of this object.
Node * | getParentNode (void) const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
Real | getPointExtrusionDistance (const Light *l) const override
| Get the distance to extrude for a point/spot light.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
bool | getReceivesShadows ()
| Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity.
virtual uint32 | getTypeFlags (void) const
| Get the 'type flags' for this MovableObject.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const override
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
bool | isParentTagPoint () const
| Gets whether the parent node is a TagPoint (or a SceneNode).
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this entity will be rendered through.
void | setUserAny (const Any &anything)
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::ShadowCaster
virtual | ~ShadowCaster ()
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Gets the world space bounding box of the dark cap, as extruded using the light provided.
virtual EdgeData * | getEdgeList (void)
| Returns details of the edges which might be used to determine a silhouette.
const AxisAlignedBox & | getLightCapBounds (void) const
| Gets the world space bounding box of the light cap.
virtual const ShadowRenderableList & | getShadowVolumeRenderableList (const Light *light, const HardwareIndexBufferPtr &indexBuffer, size_t &indexBufferUsedSize, float extrusionDistance, int flags=0)
| Gets an list of the renderables required to render the shadow volume.
bool | hasEdgeList ()
| Returns whether the object has a valid edge list.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
virtual const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
uint16 | _getMaterialLodIndex () const
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
const Vector4f & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual uint16 | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4f &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
void | setUserAny (const Any &anything)
Public Member Functions inherited from Ogre::FrameListener
virtual | ~FrameListener ()
virtual bool | frameEnded (const FrameEvent &evt)
| Called just after a frame has been rendered.
virtual bool | frameRenderingQueued (const FrameEvent &evt)
| Called after all render targets have had their rendering commands issued, but before render windows have been asked to flip their buffers over.

## Static Public Attributes
static const String | MOVABLE_TYPE_NAME
| The type name.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::MovableObject
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
Static Public Member Functions inherited from Ogre::ShadowCaster
static void | clearShadowRenderableList (ShadowRenderableList &shadowRenderables)
| Common implementation of releasing shadow renderables.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.

## Detailed Description

A single volume chunk mesh.

## Member Typedef Documentation

## ◆ VecChunk

typedef std::vector<const Chunk*> Ogre::Volume::Chunk::VecChunk

A list of Chunks.

## Constructor & Destructor Documentation

## ◆ Chunk()

Ogre::Volume::Chunk::Chunk | ( | void |  | ) |

Constructor.

Referenced by createInstance().

## ◆ ~Chunk()

virtual Ogre::Volume::Chunk::~Chunk | ( | void |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ getMovableType()

const String & Ogre::Volume::Chunk::getMovableType | ( | void |  | ) | const
| overridevirtual

Overridden from MovableObject.

Reimplemented from Ogre::SimpleRenderable.

## ◆ getSquaredViewDepth()

Real Ogre::Volume::Chunk::getSquaredViewDepth | ( | const Camera * | camera | ) | const
| overridevirtual

Overridden from Renderable.

Implements Ogre::Renderable.

## ◆ getBoundingRadius()

Real Ogre::Volume::Chunk::getBoundingRadius | ( |  | ) | const
| overridevirtual

Overridden from MovableObject.

Implements Ogre::MovableObject.

## ◆ load() [1/2]

virtual void Ogre::Volume::Chunk::load | ( | SceneNode * | parent,
|  | const Vector3 & | from,
|  | const Vector3 & | to,
|  | size_t | level,
|  | const ChunkParameters * | parameters )
| virtual

Loads the volume mesh with all LODs.

Parameters

  parent | The parent scene node for the volume
  from | The back lower left corner of the cell.
  to | The front upper right corner of the cell.
  level | The amount of LOD level.
  parameters | The parameters to use while loading.

## ◆ load() [2/2]

virtual void Ogre::Volume::Chunk::load | ( | SceneNode * | parent,
|  | SceneManager * | sceneManager,
|  | const String & | filename,
|  | bool | validSourceResult = false,
|  | MeshBuilderCallback * | lodCallback = 0,
|  | const String & | resourceGroup = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )
| virtual

Loads a TextureSource volume scene from a config file.

Parameters

  parent | The parent scene node for the volume.
  sceneManager | The scenemanager to construct the entity with.
  filename | The filename of the configuration file.
  validSourceResult | If you want to use the loaded source afterwards of the parameters, set this to true. Beware, that you will have to delete the pointer on your own then! On false here, it internally frees the memory for you
  lodCallback | Callback for a specific LOD level.
  resourceGroup | The resource group where to search for the configuration file.

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ setDualGridVisible()

virtual void Ogre::Volume::Chunk::setDualGridVisible | ( | const bool | visible | ) |
| virtual

Shows the debug visualization entity of the dualgrid.

Parameters

  visible | Whether the grid should be visible.

## ◆ getDualGridVisible()

virtual bool Ogre::Volume::Chunk::getDualGridVisible | ( | void |  | ) | const
| virtual

Gets whether the debug visualization entity of the dualgrid is visible.

Returns
  true if visible.

## ◆ setOctreeVisible()

virtual void Ogre::Volume::Chunk::setOctreeVisible | ( | const bool | visible | ) |
| virtual

Shows the debug visualization entity of the octree.

Parameters

  visible | Whether the octree should be visible.

## ◆ getOctreeVisible()

virtual bool Ogre::Volume::Chunk::getOctreeVisible | ( | void |  | ) | const
| virtual

Gets whether the debug visualization entity of the octree is visible.

Returns
  true if visible.

## ◆ setVolumeVisible()

virtual void Ogre::Volume::Chunk::setVolumeVisible | ( | const bool | visible | ) |
| virtual

Sets whether the volume mesh is visible.

Parameters

  visible | true if visible

## ◆ getVolumeVisible()

virtual bool Ogre::Volume::Chunk::getVolumeVisible | ( | void |  | ) | const
| virtual

Gets whether the volume mesh is visible.

Returns
  true if visible

## ◆ frameStarted()

bool Ogre::Volume::Chunk::frameStarted | ( | const FrameEvent & | evt | ) |
| overridevirtual

Overridden from FrameListener.

Reimplemented from Ogre::FrameListener.

## ◆ createInstance()

virtual Chunk * Ogre::Volume::Chunk::createInstance | ( | void |  | ) |
| virtual

Overridable factory method.

Returns
  The created chunk.

References Chunk().

## ◆ setMaterial()

void Ogre::Volume::Chunk::setMaterial | ( | const MaterialPtr & | mat | ) |
| overridevirtual

Overridden from SimpleRenderable.

Sets the material of this chunk and all of his children.

Reimplemented from Ogre::SimpleRenderable.

References Ogre::SimpleRenderable::setMaterial().

## ◆ setMaterialOfLevel()

void Ogre::Volume::Chunk::setMaterialOfLevel | ( | size_t | level,
|  | const MaterialPtr & | mat )

Sets the material of all chunks of a specific level in the tree.

This allows LODs where the lower levels (== less detail and more far away) have simpler materials.

Parameters

  level | The tree level getting the material, 0 based. 0 means the chunk with the lowest level of detail.
  mat | The material name to set.

## ◆ getChunksOfLevel()

virtual void Ogre::Volume::Chunk::getChunksOfLevel | ( | const size_t | level,
|  | VecChunk & | result ) const
| virtual

Gathers all visible chunks (containing triangles) of a specific LOD level.

Parameters

  level | The desired chunk level, 0 based. 0 means the chunk with the lowest level of detail. If the chunks are loaded with a level amount of 5, valid values here are 0-4.
  result | Vector where the chunks will be added to.

## ◆ getChunkParameters()

ChunkParameters * Ogre::Volume::Chunk::getChunkParameters | ( | void |  | ) |

Gets the parameters with which the chunktree got loaded.

Returns
  The parameters.

## Member Data Documentation

## ◆ MOVABLE_TYPE_NAME

const String Ogre::Volume::Chunk::MOVABLE_TYPE_NAME
| static

The type name.

The documentation for this class was generated from the following file:

- OgreVolumeChunk.h